diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenCredits.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenCredits.java
index 93a125867..723b1c19a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenCredits.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenCredits.java
@@ -2,13 +2,19 @@ package net.minecraft.client.gui;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.Scissor;
+import net.minecraft.client.render.font.Alignment;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.slf4j.Logger;
@@ -51,7 +57,10 @@ public class ScreenCredits extends Screen {
 
     private List<String> lines;
 
-    private float hue = 0;
+    private final List<CreditElement> creditElements = new ArrayList<>();
+    private int creditsHeight = 0;
+    private @Nullable CreditElement overlayElement = null;
+
 
     public ScreenCredits(Screen parent) {
         super(parent);
@@ -75,6 +84,37 @@ public class ScreenCredits extends Screen {
             this.lines = new ArrayList<>();
             this.lines.add("An error occurred while loading the credits.");
         }
+
+        this.creditsHeight = 0;
+        for (int i = 0, size = this.lines.size(); i < size; i++) {
+            String line = this.lines.get(i);
+
+            CreditElement element = null;
+            if (line.startsWith("*")) {
+                element = new Category(line.substring(1));
+            } else if (line.startsWith("!")) {
+                element = new Thanks(line.substring(1));
+            } else {
+                StringBuilder contributions = new StringBuilder();
+                int j = i;
+                while (j + 1 < size) {
+                    String credit = this.lines.get(j + 1);
+                    if (credit.startsWith("--")) {
+                        if (contributions.isEmpty()) contributions.append("Contributions: \n");
+                        contributions.append(" • ").append(credit.substring(2).strip()).append("\n");
+                        j++;
+                    } else {
+                        break;
+                    }
+                }
+                i = j;
+                element = new Credit(line, contributions.toString());
+            }
+            if (element != null) {
+                this.creditsHeight += element.height(this);
+                this.creditElements.add(element);
+            }
+        }
     }
 
     @Override
@@ -92,7 +132,7 @@ public class ScreenCredits extends Screen {
 
     @Override
     public void tick() {
-        if (!this.playing) {
+        if (!this.playing || !SoundEngine.getSoundSystem().playing(SoundEngine.STREAMING)) {
             this.mc.sndManager.playMusic(SONGS[(int) (Math.random() * SONGS.length)], 0, 0, 0, 1.0f, 1.0f);
             this.playing = true;
         }
@@ -123,31 +163,37 @@ public class ScreenCredits extends Screen {
         drawStringCenteredNoShadow(this.fontRenderer, I18n.getInstance().translateKey("gui.credits.label.title"), this.width / 2, 5, 0xFFFFFF);
 
         Scissor.enable(0, this.top, this.width, this.bottom - this.top);
-        drawContent();
+        drawContent(mx, my, partialTick);
         Scissor.disable();
-
-        this.hue = (this.hue + 1) % 360f;
     }
 
-    private void drawContent() {
+    private void drawContent(int mx, int my, float partialTick) {
         this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         drawTexturedModalRect(this.width / 2 - 274 / 2, 30 - (int) this.scrollAmount, 0, 0, 274, 50, 1d / 274, 1d / 50);
 
-        for (int i = 0; i < this.lines.size(); i++) {
-            String line = this.lines.get(i);
-            if (line.startsWith("*")) {
-                line = TextFormatting.BOLD + line.substring(1);
-                int lineWidth = MathHelper.ceil(this.fontRenderer.stringWidthDouble(line)) + line.length();
-                drawStringNoShadow(this.fontRenderer, line, this.width / 2 - lineWidth / 2, 100 + i * 12 - (int) this.scrollAmount, 0xFFFFFF);
-            } else if (line.startsWith("!")) {
-                int rgb = Color.HSBtoRGB(this.hue / 360f, 1.0f, 1.0f);
-                line = TextFormatting.BOLD + line.substring(1);
-                int lineWidth = MathHelper.ceil(this.fontRenderer.stringWidthDouble(line)) + line.length();
-                drawStringNoShadow(this.fontRenderer, line, this.width / 2 - lineWidth / 2, 100 + i * 12 - (int) this.scrollAmount, rgb);
-            } else {
-                drawStringNoShadow(this.fontRenderer, line, MathHelper.ceil((this.width - this.fontRenderer.stringWidthDouble(line)) / 2), 100 + i * 12 - (int) this.scrollAmount, 0x7F7F7F);
-            }
+        int y = (int) (100 - this.scrollAmount);
+        for (int i = 0, size = this.creditElements.size(); i < size; i++) {
+            CreditElement element = this.creditElements.get(i);
+
+            int elemWidth = element.width(this);
+            int elemHeight = element.height(this);
+
+            int minX = (this.width - elemWidth)/2;
+            int maxX = (this.width + elemWidth)/2;
+            int minY = y;
+            int maxY = y + elemHeight;
+
+//            drawBox(minX, minY, maxX, maxY, 0xFFAAAAAA, 1); // Render clickable box bounds
+
+            boolean hovered = minX <= mx && mx <= maxX && minY <= my && my <= maxY;
+
+            element.render(this, y, hovered, partialTick);
+            y += elemHeight + 1;
+        }
+
+        if (this.overlayElement != null) {
+            this.overlayElement.overlayRender(this, mx, my, partialTick);
         }
     }
 
@@ -200,6 +246,39 @@ public class ScreenCredits extends Screen {
 
         this.clickX = mx;
         this.clickY = my;
+
+        if (buttonNum == 0) {
+            if (this.overlayElement != null) {
+                int elemWidth = this.overlayElement.overlayWidth(this);
+                int elemHeight = this.overlayElement.overlayHeight(this);
+
+                int minX = this.overlayElement.overlayX(this);
+                int maxX = minX + elemWidth;
+                int minY = this.overlayElement.overlayY(this);
+                int maxY = minY + elemHeight;
+                if (minX > mx || mx > maxX || minY > my || my > maxY) {
+                    this.overlayElement = null;
+                }
+            } else {
+                int y = (int) (100 - this.scrollAmount);
+                for (int i = 0, size = this.creditElements.size(); i < size; i++) {
+                    CreditElement element = this.creditElements.get(i);
+
+                    int elemWidth = element.width(this);
+                    int elemHeight = element.height(this);
+
+                    int minX = (this.width - elemWidth)/2;
+                    int maxX = (this.width + elemWidth)/2;
+                    int minY = y;
+                    int maxY = y + elemHeight;
+                    if (minX <= mx && mx <= maxX && minY <= my && my <= maxY) {
+                        element.onClick(this);
+                        break;
+                    }
+                    y += elemHeight + 1;
+                }
+            }
+        }
     }
 
     @Override
@@ -254,7 +333,7 @@ public class ScreenCredits extends Screen {
     }
 
     private int getTotalPageHeight() {
-        return 100 + this.lines.size() * 12;
+        return 150 + this.creditsHeight;
     }
 
     @Override
@@ -266,4 +345,176 @@ public class ScreenCredits extends Screen {
             this.clickY = null;
         }
     }
+
+    @Override
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (this.overlayElement != null) {
+            if (eventKey == Keyboard.KEY_BACK) {
+                this.overlayElement = null;
+            }
+            if (eventKey == Keyboard.KEY_ESCAPE) {
+                this.overlayElement = null;
+            }
+        } else {
+            super.keyPressed(eventCharacter, eventKey, mx, my);
+        }
+    }
+
+    public interface CreditElement {
+        void render(@NotNull ScreenCredits screenCredits, int y, boolean hovered, float partialTick);
+        void onClick(@NotNull ScreenCredits screenCredits);
+        int height(@NotNull ScreenCredits screenCredits);
+        int width(@NotNull ScreenCredits screenCredits);
+
+        default void overlayRender(@NotNull ScreenCredits screenCredits, int mx, int my, float partialTick) {}
+        default int overlayX(@NotNull ScreenCredits screenCredits) { return 0; }
+        default int overlayY(@NotNull ScreenCredits screenCredits) { return 0; }
+        default int overlayWidth(@NotNull ScreenCredits screenCredits) { return 0; }
+        default int overlayHeight(@NotNull ScreenCredits screenCredits) { return 0; }
+    }
+    public record Category(@NotNull String name) implements CreditElement {
+
+        @Override
+        public void render(@NotNull ScreenCredits screenCredits, int y, boolean hovered, float partialTick) {
+            screenCredits.fontRenderer.renderCentered(this.name, (screenCredits.width - this.name.length())/2, y).setZ(screenCredits.zLevel).setColor(0xFFFFFF).setBold().call();
+        }
+
+        @Override
+        public void onClick(@NotNull ScreenCredits screenCredits) {
+
+        }
+
+        @Override
+        public int height(@NotNull ScreenCredits screenCredits) {
+            return screenCredits.fontRenderer.getFont().fontHeight() + 1;
+        }
+
+        @Override
+        public int width(@NotNull ScreenCredits screenCredits) {
+            return MathHelper.ceil(screenCredits.fontRenderer.stringWidthDouble(this.name)) + this.name.length();
+        }
+    }
+    public record Credit(@NotNull String name, @NotNull String contributions) implements CreditElement{
+        @Override
+        public void render(@NotNull ScreenCredits screenCredits, int y, boolean hovered, float partialTick) {
+            screenCredits.fontRenderer.renderCentered(this.name, screenCredits.width/2, y).setZ(screenCredits.zLevel).setColor(hovered ? 0xFFFFA0 : 0x7F7F7F).call();
+        }
+
+        @Override
+        public void onClick(@NotNull ScreenCredits screenCredits) {
+            screenCredits.overlayElement = this;
+            screenCredits.mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+        }
+
+        @Override
+        public int height(@NotNull ScreenCredits screenCredits) {
+            return screenCredits.fontRenderer.getFont().fontHeight() + 1;
+        }
+
+        @Override
+        public int width(@NotNull ScreenCredits screenCredits) {
+            return MathHelper.ceil(screenCredits.fontRenderer.stringWidthDouble(this.name));
+        }
+
+        @Override
+        public void overlayRender(@NotNull ScreenCredits screenCredits, int mx, int my, float partialTick) {
+            final int color = GameSettings.GUI_BACKGROUND_COLOR.value.getARGB();
+            screenCredits.drawGradientRect(0, 0, screenCredits.width, screenCredits.height, color, color);
+
+            int width = overlayWidth(screenCredits);
+            int height = overlayHeight(screenCredits);
+            int x = overlayX(screenCredits);
+            int y = overlayY(screenCredits);
+
+            int top = y + topSize(screenCredits);
+            int bottom = y + height - bottomSize(screenCredits);
+
+            screenCredits.drawRect(x - 1, y - 1, x + width + 1, y + height + 1, 0xFFA0A0A0);
+
+            TessellatorGeneral t = GLRenderer.getTessellator();
+            final float f = 32F;
+            t.startDrawingQuads();
+            screenCredits.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            t.setColorOpaque1i(0x404040);
+            t.addVertexWithUV(x, y + height, 0.0D, 0.0D, (float) height / f);
+            t.addVertexWithUV(x + width, y + height, 0.0D, (float) width / f, (float) height / f);
+            t.addVertexWithUV(x + width, y, 0.0D, (float) width / f, 0);
+            t.addVertexWithUV(x, y, 0.0D, 0.0D, 0);
+
+            t.setColorOpaque1i(0x202020);
+            t.addVertexWithUV(x, bottom, 0.0D, 0, (float) (top - bottom) / f);
+            t.addVertexWithUV(x + width, bottom, 0.0D, (float) width / f, (float) (top - bottom) / f);
+            t.addVertexWithUV(x + width, top, 0.0D, (float) width / f, 0);
+            t.addVertexWithUV(x, top, 0.0D, 0, 0);
+
+            t.draw();
+
+            screenCredits.fontRenderer.renderWidthConstrained(this.name, (screenCredits.width - width)/2, y + 2, width - 20).setAlignment(Alignment.CENTERED).setZ(screenCredits.zLevel).setColor(0xFFFFFF).setBold().call();
+            screenCredits.fontRenderer.renderWidthConstrained(this.contributions, x + 1, y + topSize(screenCredits) + 2, width - 2).setColor(0x7F7F7F).call();
+        }
+
+        @Override
+        public int overlayX(@NotNull ScreenCredits screenCredits) {
+            return (screenCredits.width - overlayWidth(screenCredits))/2;
+        }
+
+        @Override
+        public int overlayY(@NotNull ScreenCredits screenCredits) {
+            return (screenCredits.height - overlayHeight(screenCredits))/2;
+        }
+
+        private int topSize(@NotNull ScreenCredits screenCredits) {
+            return (int) screenCredits.fontRenderer.heightOfConstrainedChars(this.name, overlayWidth(screenCredits) - 20) + 4;
+        }
+
+        private int bottomSize(@NotNull ScreenCredits screenCredits) {
+            return 0;
+        }
+
+        private int contentSize(@NotNull ScreenCredits screenCredits) {
+            if (this.contributions.isBlank()) return 0;
+            int width = overlayWidth(screenCredits);
+            return (int) screenCredits.fontRenderer.heightOfConstrainedChars(this.contributions, width) + 4;
+        }
+
+        @Override
+        public int overlayWidth(@NotNull ScreenCredits screenCredits) {
+            return 200;
+        }
+
+        @Override
+        public int overlayHeight(@NotNull ScreenCredits screenCredits) {
+            return topSize(screenCredits) + contentSize(screenCredits) + bottomSize(screenCredits);
+        }
+    }
+    public static class Thanks implements CreditElement {
+        private final @NotNull String message;
+
+        public Thanks(@NotNull String message) {
+            this.message = message;
+        }
+
+        private float hue = 0;
+        @Override
+        public void render(@NotNull ScreenCredits screenCredits, int y, boolean hovered, float partialTick) {
+            int rgb = Color.HSBtoRGB(this.hue / 360f, 1.0f, 1.0f);
+            screenCredits.fontRenderer.renderCentered(this.message, (screenCredits.width - this.message.length())/2, y).setZ(screenCredits.zLevel).setColor(rgb).setBold().call();
+            this.hue = (this.hue + 1) % 360f;
+        }
+
+        @Override
+        public void onClick(@NotNull ScreenCredits screenCredits) {
+
+        }
+
+        @Override
+        public int height(@NotNull ScreenCredits screenCredits) {
+            return screenCredits.fontRenderer.getFont().fontHeight() + 1;
+        }
+
+        @Override
+        public int width(@NotNull ScreenCredits screenCredits) {
+            return MathHelper.ceil(screenCredits.fontRenderer.stringWidthDouble(this.message)) - this.message.length();
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index e75c5ebd0..5fe4cd627 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -374,15 +374,38 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericTorch<>(Blocks.TORCH_REDSTONE_IDLE, "minecraft:block/torch_redstone_idle").render3D(false));
         addDispatch(new BlockModelGenericTorch<>(Blocks.TORCH_REDSTONE_ACTIVE, "minecraft:block/torch_redstone_active").render3D(false));
 
-        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_STONE, "minecraft:block/button/stone"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_STONE, "minecraft:block/button/stone/stone"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_BASALT, "minecraft:block/button/stone/basalt"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_LIMESTONE, "minecraft:block/button/stone/limestone"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_GRANITE, "minecraft:block/button/stone/granite"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_PERMAFROST, "minecraft:block/button/stone/permafrost"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_NETHERRACK, "minecraft:block/button/stone/netherrack"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_GLOOMSTONE, "minecraft:block/button/stone/gloomstone"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_SANDSTONE, "minecraft:block/button/stone/sandstone"));
+        addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_BRIMSTONE, "minecraft:block/button/stone/brimstone"));
         addDispatch(new BlockModelGenericButton<>(Blocks.BUTTON_PLANKS, "minecraft:block/button/planks/oak"));
         addDispatch(new BlockModelGenericButtonPainted<>(Blocks.BUTTON_PLANKS_PAINTED));
 
         addDispatch(new BlockModelGenericLever<>(Blocks.LEVER_COBBLE_STONE).render3D(false));
 
-        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_STONE, "minecraft:block/pressure_plate/stone"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_STONE, "minecraft:block/pressure_plate/stone/stone"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_BASALT, "minecraft:block/pressure_plate/stone/basalt"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_LIMESTONE, "minecraft:block/pressure_plate/stone/limestone"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_GRANITE, "minecraft:block/pressure_plate/stone/granite"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_PERMAFROST, "minecraft:block/pressure_plate/stone/permafrost"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_NETHERRACK, "minecraft:block/pressure_plate/stone/netherrack"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_GLOOMSTONE, "minecraft:block/pressure_plate/stone/gloomstone"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_SANDSTONE, "minecraft:block/pressure_plate/stone/sandstone"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_BRIMSTONE, "minecraft:block/pressure_plate/stone/brimstone"));
+
         addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_PLANKS_OAK, "minecraft:block/pressure_plate/planks/oak"));
-        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_COBBLE_STONE, "minecraft:block/pressure_plate/cobbled_stone"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_COBBLE_STONE, "minecraft:block/pressure_plate/cobbled/stone"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_COBBLE_BASALT, "minecraft:block/pressure_plate/cobbled/basalt"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_COBBLE_LIMESTONE, "minecraft:block/pressure_plate/cobbled/limestone"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_COBBLE_GRANITE, "minecraft:block/pressure_plate/cobbled/granite"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_COBBLE_PERMAFROST, "minecraft:block/pressure_plate/cobbled/permafrost"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_COBBLE_NETHERRACK, "minecraft:block/pressure_plate/cobbled/netherrack"));
+        addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_COBBLE_GLOOMSTONE, "minecraft:block/pressure_plate/cobbled/gloomstone"));
         addDispatch(new BlockModelGenericPressurePlatePainted<>(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED));
 
         addDispatch(new BlockModelGenericVeryRotatable<>(Blocks.MOTION_SENSOR_IDLE, loadDataModel("minecraft:block/motion_sensor_idle")));
diff --git a/game/client/src/main/resources/shaders/particle.vsh b/game/client/src/main/resources/shaders/particle.vsh
index 8e00c2704..fe9e62ba4 100644
--- a/game/client/src/main/resources/shaders/particle.vsh
+++ b/game/client/src/main/resources/shaders/particle.vsh
@@ -29,5 +29,5 @@ void main() {
     LightMapCoord = unpackLightCoord();
 
     TexCoord = aUv + (((aMesh * vec2(1, -1)) + vec2(1, 1))/2.0) * aUvSizes;
-    gl_Position = matrices.projection * matrices.view * model * (vec4(aPos, 1) + matrices.viewInv * vec4(aMesh.x,  aMesh.y, 0.0, 1.0) * aScale);
+    gl_Position = matrices.projection * matrices.view * model * (vec4(aPos, 1) + matrices.viewInv * vec4(aMesh, 0.0, 0.0) * aScale);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index 9784c72c7..09d99f924 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -87,7 +87,9 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
+        world.noNeighborUpdate = true; // TODO: this should just be a temporary solution. refactor rails later!
         performRailTurn(world, tilePos, true);
+        world.noNeighborUpdate = false;
         if (this.block == Blocks.RAIL_POWERED) {
             onNeighborChanged(world, tilePos, this.block);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
index 540fa475e..41b10f73c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTorch.java
@@ -5,7 +5,9 @@ import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.ISupportable;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
@@ -73,47 +75,23 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
-        if (side.isHorizontal()) side = side.opposite();
-        onPlacedOnSide(world, tilePos, side, xHit, yHit);
-    }
+    public int getPlacedData(
+        @Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world,
+        @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit
+    ) {
+        if (player == null && side.isHorizontal()) side = side.opposite();
 
-    @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int orientation = SIDE_NONE;
-        if (side.isHorizontal()) side = side.opposite();
-        switch (side) {
-            case TOP:
-                if (isSupported(world, tilePos, Side.BOTTOM)) {
-                    orientation = SIDE_BOTTOM;
-                }
-                break;
-            case NORTH:
-                if (isSupported(world, tilePos, Side.SOUTH)) {
-                    orientation = SIDE_SOUTH;
-                }
-                break;
-            case SOUTH:
-                if (isSupported(world, tilePos, Side.NORTH)) {
-                    orientation = SIDE_NORTH;
-                }
-                break;
-            case WEST:
-                if (isSupported(world, tilePos, Side.EAST)) {
-                    orientation = SIDE_EAST;
-                }
-                break;
-            case EAST:
-                if (isSupported(world, tilePos, Side.WEST)) {
-                    orientation = SIDE_WEST;
-                }
-                break;
-        }
-        if (orientation == SIDE_NONE) {
-            orientation = getDefaultOrientation(world, tilePos);
-        }
-        world.setBlockDataNotify(tilePos, orientation);
-        dropTorchIfCantStay(world, tilePos);
+        if (isSupported(world, tilePos, side.opposite())) orientation = switch (side) {
+            default -> SIDE_NONE;
+            case TOP ->  SIDE_BOTTOM;
+            case NORTH ->  SIDE_SOUTH;
+            case SOUTH ->  SIDE_NORTH;
+            case WEST ->  SIDE_EAST;
+            case EAST ->  SIDE_WEST;
+        };
+        if (orientation == SIDE_NONE) orientation = getDefaultOrientation(world, tilePos);
+        return orientation;
     }
 
     public int getDefaultOrientation(@NotNull World world, @NotNull TilePosc tilePos) {
@@ -141,9 +119,12 @@ public class BlockLogicTorch extends BlockLogic implements ISupportable {
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
-        int orientation = getDefaultOrientation(world, tilePos);
-        if (orientation != SIDE_NONE) {
-            world.setBlockDataNotify(tilePos, orientation);
+        int data = world.getBlockData(tilePos);
+        if (data == SIDE_NONE) {
+            int orientation = getDefaultOrientation(world, tilePos);
+            if (orientation != SIDE_NONE) {
+                world.setBlockDataNotify(tilePos, orientation);
+            }
         }
         dropTorchIfCantStay(world, tilePos);
     }
